---
title: Headers.set()
slug: Web/API/Headers/set
tags:
  - API
  - Experimental
  - Fetch
  - Method
  - Reference
  - set
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>set()</code></strong> method of the {{domxref("Headers")}} interface sets a new value for an existing header inside a <code>Headers</code> object, or adds the header if it does not already exist.</p>

<p>The difference between <code>set()</code> and {{domxref("Headers.append")}} is that if the specified header already exists and accepts multiple values, <code>set()</code> overwrites the existing value with the new one, whereas {{domxref("Headers.append")}} appends the new value to the end of the set of values.</p>

<p>For security reasons, some headers can only be controller by the user agent. These headers include the {{Glossary("Forbidden_header_name", "forbidden header names", 1)}} and {{Glossary("Forbidden_response_header_name", "forbidden response header names", 1)}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>myHeaders</em>.set(<em>name</em>, <em>value</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>name</code></dt>
 <dd>The name of the HTTP header you want to set to a new value. If the given name is not the name of an HTTP header, this method throws a {{jsxref("TypeError")}}.</dd>
 <dt><code>value</code></dt>
 <dd>The new value you want to set.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>Void.</p>

<h2 id="Example">Example</h2>

<p>Creating an empty <code>Headers</code> object is simple:</p>

<pre class="brush: js">var myHeaders = new Headers(); // Currently empty</pre>

<p>You could add a header to this using {{domxref("Headers.append")}}, then set a new value for this header using <code>set()</code>:</p>

<pre class="brush: js">myHeaders.append('Content-Type', 'image/jpeg');
myHeaders.set('Content-Type', 'text/html');
</pre>

<p>If the specified header does not already exist, <code>set()</code> will create it and set its value to the specified value. If the specified header does already exist and does accept multiple values, <code>set()</code> will overwrite the existing value with the new one:</p>

<pre class="brush: js">myHeaders.set('Accept-Encoding', 'deflate');
myHeaders.set('Accept-Encoding', 'gzip');
myHeaders.get('Accept-Encoding'); // Returns 'gzip'</pre>

<p>You'd need {{domxref("Headers.append")}} to append the new value onto the values, not overwrite it.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Fetch','#dom-headers-set','set()')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Headers.set")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
